<?php

class Unirgy_DropshipGeoProximity_Helper_Data extends Mage_Core_Helper_Abstract
{
    public function getShippingLocation2($items)
    {
        $method = Mage::getStoreConfig('udropship/geoproximity/method');
        if ($method=='geoip' && Mage::helper('udropship')->isModuleActive('Unirgy_GeoIP')) {
            return Mage::helper('ugeoip')->getGeoLocation();
        }

        foreach ($items as $item) {
            $quote = $item->getQuote();
            break;
        }
        if (!$quote) {
            return $this->_getDefaultLocation();
        }
        $address = $quote->getShippingAddress() ? $quote->getShippingAddress() : $quote->getBillingAddress();
        foreach ($items as $item) {
            if ($item->getAddress()) {
                $address = $item->getAddress();
            }
            break;
        }

        if (!$address) {
            return $this->_getDefaultLocation();
        }

        if (!$address->getCity() && !$address->getPostcode()) {
            return $this->_getDefaultLocation();
        }
        $addressString = $address->getCity().', '.$address->getPostcode().', '.$address->getCountryId();

        $location = $this->fetchCoordinates($addressString);
        if (!$location->hasLatitude()) {
            return $this->_getDefaultLocation();
        }

        return $location;
    }
    public function getShippingLocation()
    {
        $method = Mage::getStoreConfig('udropship/geoproximity/method');
        if ($method=='geoip' && Mage::helper('udropship')->isModuleActive('Unirgy_GeoIP')) {
            return Mage::helper('ugeoip')->getGeoLocation();
        }

        $quote = Mage::helper('udropship/protected')->getQuote();
        if (!$quote) {
            $quote = Mage::getSingleton('checkout/session')->getQuote();
        }
        if (!$quote) {
            return $this->_getDefaultLocation();
        }
        $address = $quote->getShippingAddress() ? $quote->getShippingAddress() : $quote->getBillingAddress();
        if (!$address) {
            return $this->_getDefaultLocation();
        }
        if (!$address->getCity() && !$address->getPostcode()) {
            return $this->_getDefaultLocation();
        }
        $addressString = $address->getCity().', '.$address->getPostcode().', '.$address->getCountryId();

        $location = $this->fetchCoordinates($addressString);
        if (!$location->hasLatitude()) {
            return $this->_getDefaultLocation();
        }

        return $location;
    }

    public function hasLatitude()
    {
        return false;
    }

    protected function _getDefaultLocation()
    {
        $lVendor = $vendors = Mage::getResourceModel('udgeoproximity/vendor_collection')
            ->addVendorFilter(Mage::helper('udropship')->getLocalVendorId())
            ->joinLocation()
            ->getFirstItem();
        if ($lVendor->getId()) {
            return new Varien_Object(array('latitude'=>$lVendor->latitude,'longitude'=>$lVendor->longitude));
        } else {
            return false;
        }
    }

    public function fetchCoordinates($address)
    {
        $cacheKey = md5($address);
        if (($cache = Mage::app()->loadCache($cacheKey)) && ($_result = @unserialize($cache)) && $_result instanceof Varien_Object && $_result->hasLatitude()) {
            return $_result;
        } else {
            $url = Mage::getStoreConfig('udropship/geoproximity/google_geo_url');
            if (!$url) {
                $url = "http://maps.googleapis.com/maps/api/geocode/json";
            }
            $url .= strpos($url, '?')!==false ? '&' : '?';
            $url .= 'address='.urlencode(preg_replace('#\r|\n#', ' ', $address))."&sensor=false";

            $cinit = curl_init();
            curl_setopt($cinit, CURLOPT_URL, $url);
            curl_setopt($cinit, CURLOPT_HEADER,0);
            curl_setopt($cinit, CURLOPT_USERAGENT, $_SERVER["HTTP_USER_AGENT"]);
            curl_setopt($cinit, CURLOPT_RETURNTRANSFER, 1);
            $response = curl_exec($cinit);
            if (!is_string($response) || empty($response)) {
                return $this;
            }
            try {
                $response = Mage::helper('core')->jsonDecode($response);
                if (is_array($response) && strtoupper(@$response['status'])=='OK'
                    && !empty($response['results']) && is_array($response['results'])
                ) {
                    $_res = $response['results'];
                    reset($_res);
                    $res = current($_res);
                    if (isset($res['geometry']['location']['lat'])
                        && isset($res['geometry']['location']['lng'])
                    ) {
                        $_result = new Varien_Object;
                        $_result->setLatitude($res['geometry']['location']['lat'])
                            ->setLongitude($res['geometry']['location']['lng']);
                        Mage::app()->saveCache(serialize($_result), $cacheKey, array(), null);
                        return $_result;
                    }
                }
            } catch (Exception $e) {
            }
        }
        return $this;
    }
}