<?php

class Unirgy_DropshipGeoProximity_Model_Mysql4_Vendor_Collection
    extends Unirgy_Dropship_Model_Mysql4_Vendor_Collection
{
    public function addAreaFilter($center_lat, $center_lng, $radius, $units='mi')
    {
        $conn = $this->getConnection();
        $res = Mage::getSingleton('core/resource');
        $dist = sprintf(
            "(%s*acos(cos(radians(%s))*cos(radians(`latitude`))*cos(radians(`longitude`)-radians(%s))+sin(radians(%s))*sin(radians(`latitude`))))",
            $units=='mi' ? 3959 : 6371,
            $conn->quote($center_lat),
            $conn->quote($center_lng),
            $conn->quote($center_lat)
        );
        $this->_select
            ->join(array('l'=>$res->getTableName('ustorelocator_location')), 'location_id=main_location_id', array('*', 'distance'=>$dist))
            ->where('`latitude` is not null and `latitude`<>0 and `longitude` is not null and `longitude`<>0 and '.$dist.'<=?', $radius)
            ->order('distance');
        return $this;
    }

    public function joinLocation()
    {
        if ($this->getFlag('joinLocation')) return $this;
        $conn = $this->getConnection();
        $res = Mage::getSingleton('core/resource');
        $this->_select
            ->join(array('l'=>$res->getTableName('ustorelocator_location')), 'location_id=main_location_id');
        $this->setFlag('joinLocation', 1);
        return $this;
    }

//    public function addBoundsFilter($params)
//    {
//        $y1 = min((float)$params['n'], (float)$params['s']);
//        $y2 = max((float)$params['n'], (float)$params['s']);
//        $x1 = min((float)$params['e'], (float)$params['w']);
//        $x2 = max((float)$params['e'], (float)$params['w']);
//
//        $res = Mage::getSingleton('core/resource');
//        $this->_select
//            ->join(array('l'=>$res->getTableName('ustorelocator_location')), 'location_id=main_location_id', array('*'))
//            ->where("`latitude` between $y1 and $y2 and `longitude` between $x1 and $x2");
//
//        return $this;
//    }
}